---
import Layout from "../layouts/Layout.astro";
import { Picture } from "astro:assets";
import promotedDevices from "@data/promotedDevices.json";
import getDevices from "@logic/build/getDevices.js";

import angleIcon from "ubports-astro-components/img/symbols/angle-icon.svg";

const pageMeta = {
  title: "Promoted Devices • Ubuntu Touch • Linux Phone",
  meta: [
    {
      name: "keywords",
      content:
        "Ubuntu Touch, Privacy phone, Linux smartphone, Linux on mobile, Open Source Phone"
    },
    {
      name: "description",
      content:
        "Ubuntu Touch is the open source phone that has freedom and privacy in mind. Top-choice devices, pre-installed, long-lasting and mainline"
    },
    {
      property: "og:url",
      content: "https://devices.ubuntu-touch.io/promoted"
    },
    {
      property: "og:title",
      content: "Promoted Devices • Ubuntu Touch • Linux Phone"
    },
    {
      property: "og:description",
      content:
        "Ubuntu Touch is the open source phone that has freedom and privacy in mind. Top-choice devices, pre-installed, long-lasting and mainline"
    }
  ]
};

// Elaborate data
const unfliteredDevices = await getDevices("get-all-devices");
const devices = unfliteredDevices.filter((d) => !d.unlisted);

promotedDevices.forEach((deviceGroup, groupIdx) => {
  promotedDevices[groupIdx].devices = deviceGroup.devices.map((device) => {
    if (typeof device === "string" || device instanceof String) {
      let deviceDetails = devices.find((d) => d.codename == device);
      return {
        name: deviceDetails.name,
        image: deviceDetails.image,
        buyLink: deviceDetails.buyLink,
        path: deviceDetails.releases.default.path
      };
    } else return device;
  });
});
---

<Layout pageMeta={pageMeta}>
  <div class="promoted-page">
    <h1 class="mt-5 mb-3 h3">Promoted devices</h1>

    {
      promotedDevices.map((deviceGroup) => (
        <>
          <h2 id={deviceGroup.id} class="mb-2 mt-5 h4">
            {deviceGroup.name}
          </h2>
          <p class="mb-3">{deviceGroup.description}</p>
          <div class="category-devices d-flex my-5">
            {deviceGroup.devices.map((device) => (
              <div class="device-card text-center">
                <Picture
                  src={device.image}
                  inferSize
                  formats={["avif"]}
                  alt={device.name + " picture"}
                />
                <h3 class="h5 my-3 bold">{device.name}</h3>
                <div>
                  {!!device.path && !!device.buyLink && (
                    <a href={device.buyLink} class="btn btn-secondary">
                      Shop
                    </a>
                  )}
                  {!!device.path && (
                    <a
                      href={device.path}
                      class:list={[
                        "d-inline-block",
                        "bold",
                        { "ms-4": !!device.buyLink }
                      ]}
                    >
                      Read more
                      <img
                        class="dark-invert angle-icon r-270 ms-1 d-inline"
                        src={angleIcon.src}
                        alt=""
                      />
                    </a>
                  )}
                  {!device.path && (
                    <h4 class="d-inline-block bold">Coming soon</h4>
                  )}
                </div>
              </div>
            ))}
          </div>
        </>
      ))
    }
  </div>
</Layout>
